import * as C from '../cvizzu.types.js';
export interface Canvas {
    frameBegin(): void;
    frameEnd(): void;
    setClipRect(x: number, y: number, sizex: number, sizey: number): void;
    setClipCircle(x: number, y: number, radius: number): void;
    setClipPolygon(): void;
    setBrushColor(r: number, g: number, b: number, a: number): void;
    setLineColor(r: number, g: number, b: number, a: number): void;
    setLineWidth(width: number): void;
    setFont(font: C.CString): void;
    beginDropShadow(): void;
    setDropShadowBlur(radius: number): void;
    setDropShadowColor(r: number, g: number, b: number, a: number): void;
    setDropShadowOffset(x: number, y: number): void;
    endDropShadow(): void;
    beginPolygon(): void;
    addPoint(x: number, y: number): void;
    addBezier(c0x: number, c0y: number, c1x: number, c1y: number, x: number, y: number): void;
    endPolygon(): void;
    rectangle(x: number, y: number, sizex: number, sizey: number): void;
    circle(x: number, y: number, radius: number): void;
    line(x1: number, y1: number, x2: number, y2: number): void;
    text(x: number, y: number, sizex: number, sizey: number, text: C.CString): void;
    setBrushGradient(x1: number, y1: number, x2: number, y2: number, stopCount: number, stops: C.CColorGradientPtr): void;
    transform(a: number, b: number, c: number, d: number, e: number, f: number): void;
    save(): void;
    restore(): void;
}
