import { Element, Marker, MarkerLabel, PointerEvent } from '../events.js';
import { Plugin, type PluginHooks } from '../plugins.js';
import Vizzu from '../vizzu.js';
export declare class Tooltip implements Plugin {
    private _vizzu?;
    private _id;
    private _animating;
    private _lastMarkerId;
    private _overedMarkerId;
    private _lastMove;
    get hooks(): PluginHooks;
    meta: {
        name: string;
        depends: string[];
    };
    listeners: {
        pointermove: (param: PointerEvent) => void;
        pointerleave: (param: PointerEvent) => void;
    };
    register(vizzu: Vizzu): void;
    enable(enabled: boolean): void;
    _mousemove(param: PointerEvent): void;
    _mouseleave(param: PointerEvent): void;
    _mouseon(param: PointerEvent): void;
    _getMarkerId(target: Element | null): string | null;
    _isMarker(target: Element): target is Marker;
    _isMarkerLabel(target: Element): target is MarkerLabel;
    _in(id: number, markerId: string): void;
    _out(id: number): void;
}
