import * as Data from '../types/data.js';
type CubeRow = Data.MeasureValue[] | CubeRow[];
/** Defines a data series of the data cube, and contains a particular variable's
  values in the data cube and meta info about that variable. */
interface CubeData extends Data.SeriesBase {
    /** A nested array that contains the values of the data series. Nesting
  level should match the number of data cube dimensions. */
    values: CubeRow;
}
/** N dimensional data cude */
export interface DataCube extends Data.Filter {
    /** The list of the dimensions of the data cube. */
    dimensions: Data.Series[];
    /** The list of measures of the data cube. */
    measures: CubeData[];
}
export default class UnPivot {
    static isPivot(data: Data.Set | DataCube | undefined): boolean;
    static convert(data: DataCube): Data.TableBySeries;
}
export {};
